Subject: Re: Marvell 88E609x switch?

From: Anton Vorontsov <[email-masked]>
Date: Fri, 27 Feb 2009 18:18:15 +0300

On Fri, Feb 27, 2009 at 03:25:48PM +0100, Lennert Buytenhek wrote:
> On Fri, Feb 27, 2009 at 06:22:40AM -0700, Gary Thomas wrote:
> 
> > >> However, the network subsystem still can't locate it.  It may be
> > >> a complication of the OF stuff and how the [gianfar] network
> > >> device knows what PHY to look at.
> > >>
> > >>   starting network interfaces...
> > >>   24520:01 not found
> > >>   eth0: Could not attach to PHY
> > > 
> > > It's correct that eth0 should not associate with a PHY -- since the
> > > MAC connects to the switch chip over GMII/RGMII/SGMII, there is no
> > > PHY involved.
> > 
> > Yes, but it's expecting to be able to talk to the PHYLIB layer
> > and ask things like speed, duplex, link state, etc.
> > 
> > > Is the gianfar driver refusing to up the interface without a PHY?
> > > It shouldn't do that -- IMHO it's perfectly fine to not have a PHY
> > > on your ethernet MAC.
> > 
> > It seems so, yes.  I tried disabling the PHY connection in the OF
> > tree and now eth0 doesn't even try to come up :-(
> 
> gianfar authors/maintainers: is there a way of using gianfar purely
> as a (R)(G)MII transport, i.e. without it trying to talk to a PHY?
> Gary is trying to use it to just pass packets to another
> (R)(G)MII-speaking chip that doesn't have a PHY interface, but gianfar
> seems to bail out if you don't give it a PHY to talk to.

You can use fixed-link property in the device tree, and CONFIG_FIXED_PHY
driver. See arch/powerpc/boot/dts/mpc8349emitx.dts as an example, and
Documentation/powerpc/dts-bindings/fsl/tsec.txt for the fixed-link's
fields meaning.

-- 
Anton Vorontsov
email: [email-masked]
irc://irc.freenode.net/bd2